<template>
    <div>
        <el-card :body-style="cardBodyStyle">
            <el-form :inline="true">
                <el-form-item label="原矿名称" style="margin-bottom: 5px;">
                    <el-select v-model="query.matlNm" filterable placeholder="请选择原矿名称" style="width: 230px" clearable>
                        <el-option v-for="item in matlNmList" :key="item.matlNm" :label="item.matlNm" :value="item.matlNm"  />
                    </el-select>
                </el-form-item>
            </el-form>
        </el-card>
        <ButtonBar @search="handleSearch" @add="handleAdd" @remove="handleRemoveBatch" @edit="handleEditBatch"
                   @upload="handleUpload" @download="handleDownload" @import="handleImport" @export="handleExport"></ButtonBar>
        <el-card :body-style="cardBodyStyle">
            <el-table :data="tableData" border highlight-current-row  @selection-change="handleSelectionChange" style="height: 500px;">
                <el-table-column type="selection" fixed></el-table-column>
                <!-- <el-table-column type="index" label="序号" align="center" width="60">
                    <template #default="scope">
                        <span>{{ scope.$index + (currentPage - 1) * pageSize + 1 }}</span>
                    </template>
                </el-table-column> -->
                        <el-table-column v-if="false" prop="" label="ID" width="120"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="createEmpId" label="创建人id" width="300"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="createDtm" label="创建时间" width="240"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="modifyEmpId" label="修改人id" width="300"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="modifyDtm" label="修改时间" width="240"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="cancleEmpId" label="删除人ID" width="300"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="cancleDtm" label="删除时间" width="240"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="false" prop="cancleYn" label="删除标记" width="240"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="propSeq" label="配矿序号" width="90"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="matlNm" label="原矿名称" width="150"
                                         header-align="center" align="center"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="propMin" label="配比下限" width="110"
                                         header-align="center" align="right"
                                         show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="propMax" label="配比上限" width="110"
                                         header-align="center" align="right"
                                         show-overflow-tooltip>
                        </el-table-column>
                        


                <el-table-column label="操作" header-align="center" align="center" width="200px" fixed="right">
                    <template #default="scope">
                        <el-button plain type="warning" @click="handleEdit(scope.row)">编辑</el-button>
                        <el-button plain type="danger" @click="handleDelete(scope.row )">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
        </el-card>
        <el-card :body-style="cardBodyStyle">
            <el-pagination  :current-page="currentPage"  :page-size="pageSize" :page-sizes="pageSizes"
                           :total="totalRows" background="background" layout="total, sizes, prev, pager, next, jumper"
                           @size-change="handleSizeChange" @current-change="handleCurrentChange">
            </el-pagination>
        </el-card>

        <el-dialog :close-on-click-modal="false" draggable :title="dialogName" v-model="dialogVisible" width="1200px"
                   top="5vh"  @open="openDialog" :before-close="handleCancelSave">
            <el-form :model="form" label-width="80px" label-position="right" inline ref="ruleFormRef" :rules="rules">
                <el-form-item label="原矿名称"  prop="matlNm"  >
                    <el-select v-model="form.matlNm" filterable placeholder="请选择原矿名称" style="width: 200px" >
                        <el-option v-for="item in matlNmList" :key="item.matlNm" :label="item.matlNm" :value="item.matlNm"  clearable/>
                    </el-select>
                </el-form-item>
                <el-form-item label="配比下限" prop="propMin" >
                    <el-input v-model="form.propMin" clearable style="width: 200px"></el-input>
                </el-form-item>
                <el-form-item label="配比上限" prop="propMax" >
                    <el-input v-model="form.propMax" clearable style="width: 200px"></el-input>
                </el-form-item>
                <el-form-item label="配矿序号"   prop="propSeq">
                    <el-input v-model="form.propSeq" clearable style="width: 200px"></el-input>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="success" @click="handleSave(ruleFormRef)">保存</el-button>
                    <el-button type="danger" @click="handleCancelSave">取消</el-button>
                </div>
            </template>
        </el-dialog>


    </div>
</template>

<script setup>
    import ButtonBar from '@/components/ButtonBar.vue'

    import {
        ref,
        reactive,
        onMounted,
        getCurrentInstance
    } from 'vue'

    const {
        proxy
    } = getCurrentInstance()

    import tools from '@/tools'
    const cardBodyStyle = ref(tools.style.card)
    const inputStyle = ref(tools.style.input)

    onMounted(() => {
        handleSearch()
        getmatlNmList()
    })


    // 原矿名称列表
    const matlNmList = ref([])
    const getmatlNmList = () => {
        var url = 'pla/PropMatl/query'
        var param = {
            page: 1,
            rows: 999999,
            params: JSON.stringify({
                matlNm: ''
            })
        }
       proxy.$axios.get(url, param).then(response => {
            if (response.data.code == '0') {
                matlNmList.value = response.data.data.records
            } else {
                ElMessage.error('操作失败！' + response.data.msg)
            }
        })
    }

    /**
     *   查询
     */




    const query = ref({
           matlNm: ''
   })
   const tableData = ref([])
   const handleSearch = () => {
       currentPage.value = 1
       getTableData()
   }

   const getTableData = () => {
       var url = 'pla/PropMatlIntv/query'
       var param = {
           page: currentPage.value,
           rows: pageSize.value,
           params: JSON.stringify(query.value)
       }
       proxy.$axios.get(url, param).then(response => {
            if (response.data.code == '0') {
                tableData.value = response.data.data.records
                totalRows.value = response.data.data.total
            } else {
                ElMessage.error('操作失败！' + response.data.msg)
            }
        })
    }
    /**
     *   查询
     */

    /**
     * 分页
     */
    const currentPage = ref(1)
    const totalRows = ref(0)
    const pageSizes = ref([5, 10, 20, 30, 40])
    const pageSize = ref(10)
    const handleSizeChange = (val) => {
        pageSize.value = val
        getTableData()
    }
    const handleCurrentChange = (val) => {
        currentPage.value = val
        getTableData()
    }
    /**
     * 分页
     */


    /**
     * 新增
     */
    const dialogVisible = ref(false)
    const form = ref({
        matlNm: '', 
        propMin: '', 
        propMax: '', 
        propSeq: ''
    })
    const ruleFormRef = ref()
    const rules = reactive({
        matlNm: [{
            required: true,
            message: '请输入原矿名称',
            trigger: 'change' | 'blur'
        }], 
        propMin: [{
            validator: (rule, value, callback) => {
                const propMax = parseFloat(form.value.propMax)
                const propMin = parseFloat(value)
                if (value === '') {
                    callback();
                } else if (Number.isNaN(Number(value))) {
                    callback(new Error('请输入有效数字'));
                } else if(propMin < 0){
                    callback(new Error('配比下限不能小于0'));
                } else if( (propMax != null) && (propMin >= propMax)){
                    callback(new Error('配比下限小于配比上限'));
                } else{
                    callback();
                }
            },
            trigger: 'blur'
        }], 
        propMax: [{
            validator: (rule, value, callback) => {
                const propMax = parseFloat(value)
                const propMin = parseFloat(form.value.propMin)
                if (value === '') {
                    callback();
                } else if (Number.isNaN(Number(value))) {
                    callback(new Error('请输入有效数字'));
                } else if(propMax >10){
                    callback(new Error('配比上限不能大于10'));
                }else if(propMin != null && (propMin >= propMax)){
                    callback(new Error('配比上限大于配比下限'));
                }else{
                    callback();
                }
            },
            trigger: 'blur'
        }], 
        propSeq: [{ max: 20, message: '配矿序号超过有效长度', trigger: ['change', 'blur'] }]
    })

    const dialogName =ref('')
    const handleAdd = () => {
        form.value = {
            matlNm: '', 
            propMin: '', 
            propMax: '', 
            propSeq: ''
        }
        dialogName.value = '新增'
        dialogVisible.value = true
    }
    /**
     * 新增
     */
    
    /**
     * 保存、修改、删除
     */

    const openDialog=()=>{
    }

    const handleSave = (ruleFormRef) => {
        ruleFormRef.validate((valid, fields) => {
            if (valid) {
                var url = 'pla/PropMatlIntv/save'
                var param = {
                    json: JSON.stringify(form.value),
                }
                proxy.$axios.post(url, param).then(response => {
                    if (response.data.code == 0) {
                        form.value = response.data.data
                        ElMessage({
                            message: '保存成功',
                            type: 'success',
                        })
                        getTableData()
                        dialogVisible.value = false
                    } else {
                        // ElMessage.error('操作失败！' + response.data.msg)
                        ElMessage({
                            message: '操作失败' + response.data.msg,
                            type: 'error'
                        })
                    }
                })

            } else {
                console.log('error submit!', fields)
                ElMessage.error('请输入有效数据')
            }
        })
    }
    const handleCancelSave = () => {
        dialogVisible.value = false
    }
    const handleEdit = (row) => {
        dialogName.value = '编辑'
        dialogVisible.value = true
        form.value = row
    }
    const handleDelete = (row) => {
        ElMessageBox.confirm(
            '确定删除本条记录?',
            '提示', {
                confirmButtonText: '确认',
                cancelButtonText: '取消',
                type: 'warning',
                draggable: true,
            }
        )
            .then(() => {
                var url = 'pla/PropMatlIntv/remove'
                var param = {
                    id: row.id
                }
                proxy.$axios.post(url, param).then(response => {
                    if (response.data.code == 0) {
                        ElMessage({
                            type: 'success',
                            message: '删除成功',
                        })
                        getTableData()
                    } else {
                        ElMessage({
                            type: 'error',
                            message: '删除失败' + response.data.msg
                        });
                    }
                });
            })
            .catch(() => {
                ElMessage({
                    type: 'info',
                    message: '已取消',
                })
            })
    }

    /**
     * 保存、修改、删除
     */

    const multipleSelection = ref([])
    const handleSelectionChange = (val) => {
        multipleSelection.value = val
    }

    const handleRemoveBatch = () => {
        console.log('handleRemoveBatch')

        if (multipleSelection.value.length < 1) {
            ElMessage({
                type: 'warning',
                message: '请选择要删除的数据!'
            })
            return
        }

        ElMessageBox.confirm('此操作将删除该数据, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        }).then(() => {
            var ids = []
            multipleSelection.value.forEach((item, index) => {
                ids.push(item.id)
            })
            var url = 'pla/PropMatlIntv/removeBatch'
            var param = {
                ids: JSON.stringify(ids)
            }
            proxy.$axios.post(url, param).then(response => {
                if (response.data.code == '0') {
                    ElMessage({
                        type: 'success',
                        message: '操作成功!',
                    });
                    getTableData()
                    dialogVisible.value = false
                } else {
                    ElMessage({
                        type: 'error',
                        message: '操作失败!' + response.data.msg
                    });
                }
            })
        }).catch(() => {
            ElMessage({
                type: 'info',
                message: '已取消删除'
            })
        })
    }

    const handleEditBatch = () => {
        console.log('handleEditBatch')
        if (multipleSelection.value.length != 1) {
            ElMessage({
                type: 'warning',
                message: '请选择一条数据编辑!'
            })
            return
        }
        handleEdit(multipleSelection.value[0])
    }

    const handleUpload = () => {
        console.log('handleUpload')
    }

    const handleDownload = () => {
        console.log('handleDownload')
    }

    const handleImport = () => {
        console.log('handleImport')
    }

    const handleExport = () => {
        console.log('handleExport')
    }

</script>

<style>
</style>